<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kd7w2jm6rvvx6pnfgbmafdxkx875y5cf-vendored-sources/dlmalloc-0.2.3/src/lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../dlmalloc/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../dlmalloc/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../dlmalloc/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
</pre><pre class="rust"><code><span class="doccomment">//! A Rust port of the `dlmalloc` allocator.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! The `dlmalloc` allocator is described at</span>
<span class="doccomment">//! http://g.oswego.edu/dl/html/malloc.html and this Rust crate is a straight</span>
<span class="doccomment">//! port of the C code for the allocator into Rust. The implementation is</span>
<span class="doccomment">//! wrapped up in a `Dlmalloc` type and has support for Linux, OSX, and Wasm</span>
<span class="doccomment">//! currently.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! The primary purpose of this crate is that it serves as the default memory</span>
<span class="doccomment">//! allocator for the `wasm32-unknown-unknown` target in the standard library.</span>
<span class="doccomment">//! Support for other platforms is largely untested and unused, but is used when</span>
<span class="doccomment">//! testing this crate.</span>

<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span>
<span class="attribute">#![<span class="ident">no_std</span>]</span>
<span class="attribute">#![<span class="ident">deny</span>(<span class="ident">missing_docs</span>)]</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;wasm64&quot;</span>, <span class="ident">feature</span>(<span class="ident">simd_wasm64</span>))]</span>

<span class="kw">use</span> <span class="ident">core::cmp</span>;
<span class="kw">use</span> <span class="ident">core::ptr</span>;
<span class="kw">use</span> <span class="ident">sys::System</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;global&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::global</span>::{<span class="ident">enable_alloc_after_fork</span>, <span class="ident">GlobalDlmalloc</span>};

<span class="kw">mod</span> <span class="ident">dlmalloc</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;global&quot;</span>)]</span>
<span class="kw">mod</span> <span class="ident">global</span>;

<span class="doccomment">/// In order for this crate to efficiently manage memory, it needs a way to communicate with the</span>
<span class="doccomment">/// underlying platform. This `Allocator` trait provides an interface for this communication.</span>
<span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">trait</span> <span class="ident">Allocator</span>: <span class="ident">Send</span> {
    <span class="doccomment">/// Allocates system memory region of at least `size` bytes</span>
    <span class="doccomment">/// Returns a triple of `(base, size, flags)` where `base` is a pointer to the beginning of the</span>
    <span class="doccomment">/// allocated memory region. `size` is the actual size of the region while `flags` specifies</span>
    <span class="doccomment">/// properties of the allocated region. If `EXTERN_BIT` (bit 0) set in flags, then we did not</span>
    <span class="doccomment">/// allocate this segment and so should not try to deallocate or merge with others.</span>
    <span class="doccomment">/// This function can return a `std::ptr::null_mut()` when allocation fails (other values of</span>
    <span class="doccomment">/// the triple will be ignored).</span>
    <span class="kw">fn</span> <span class="ident">alloc</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">size</span>: <span class="ident">usize</span>) -&gt; (<span class="kw-2">*mut</span> <span class="ident">u8</span>, <span class="ident">usize</span>, <span class="ident">u32</span>);

    <span class="doccomment">/// Remaps system memory region at `ptr` with size `oldsize` to a potential new location with</span>
    <span class="doccomment">/// size `newsize`. `can_move` indicates if the location is allowed to move to a completely new</span>
    <span class="doccomment">/// location, or that it is only allowed to change in size. Returns a pointer to the new</span>
    <span class="doccomment">/// location in memory.</span>
    <span class="doccomment">/// This function can return a `std::ptr::null_mut()` to signal an error.</span>
    <span class="kw">fn</span> <span class="ident">remap</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">ptr</span>: <span class="kw-2">*mut</span> <span class="ident">u8</span>, <span class="ident">oldsize</span>: <span class="ident">usize</span>, <span class="ident">newsize</span>: <span class="ident">usize</span>, <span class="ident">can_move</span>: <span class="ident">bool</span>) -&gt; <span class="kw-2">*mut</span> <span class="ident">u8</span>;

    <span class="doccomment">/// Frees a part of a memory chunk. The original memory chunk starts at `ptr` with size `oldsize`</span>
    <span class="doccomment">/// and is turned into a memory region starting at the same address but with `newsize` bytes.</span>
    <span class="doccomment">/// Returns `true` iff the access memory region could be freed.</span>
    <span class="kw">fn</span> <span class="ident">free_part</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">ptr</span>: <span class="kw-2">*mut</span> <span class="ident">u8</span>, <span class="ident">oldsize</span>: <span class="ident">usize</span>, <span class="ident">newsize</span>: <span class="ident">usize</span>) -&gt; <span class="ident">bool</span>;

    <span class="doccomment">/// Frees an entire memory region. Returns `true` iff the operation succeeded. When `false` is</span>
    <span class="doccomment">/// returned, the `dlmalloc` may re-use the location on future allocation requests</span>
    <span class="kw">fn</span> <span class="ident">free</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">ptr</span>: <span class="kw-2">*mut</span> <span class="ident">u8</span>, <span class="ident">size</span>: <span class="ident">usize</span>) -&gt; <span class="ident">bool</span>;

    <span class="doccomment">/// Indicates if the system can release a part of memory. For the `flags` argument, see</span>
    <span class="doccomment">/// `Allocator::alloc`</span>
    <span class="kw">fn</span> <span class="ident">can_release_part</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">flags</span>: <span class="ident">u32</span>) -&gt; <span class="ident">bool</span>;

    <span class="doccomment">/// Indicates whether newly allocated regions contain zeros.</span>
    <span class="kw">fn</span> <span class="ident">allocates_zeros</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">bool</span>;

    <span class="doccomment">/// Returns the page size. Must be a power of two</span>
    <span class="kw">fn</span> <span class="ident">page_size</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">usize</span>;
}

<span class="doccomment">/// An allocator instance</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Instances of this type are used to allocate blocks of memory. For best</span>
<span class="doccomment">/// results only use one of these. Currently doesn&#39;t implement `Drop` to release</span>
<span class="doccomment">/// lingering memory back to the OS. That may happen eventually though!</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Dlmalloc</span><span class="op">&lt;</span><span class="ident">A</span> <span class="op">=</span> <span class="ident">System</span><span class="op">&gt;</span>(<span class="ident">dlmalloc::Dlmalloc</span><span class="op">&lt;</span><span class="ident">A</span><span class="op">&gt;</span>);

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_family</span> <span class="op">=</span> <span class="string">&quot;wasm&quot;</span>)]</span>
<span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;wasm.rs&quot;</span>]</span>
<span class="kw">mod</span> <span class="ident">sys</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;linux&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;macos&quot;</span>))]</span>
<span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;unix.rs&quot;</span>]</span>
<span class="kw">mod</span> <span class="ident">sys</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">any</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;linux&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;macos&quot;</span>, <span class="ident">target_family</span> <span class="op">=</span> <span class="string">&quot;wasm&quot;</span>)))]</span>
<span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;dummy.rs&quot;</span>]</span>
<span class="kw">mod</span> <span class="ident">sys</span>;

<span class="kw">impl</span> <span class="ident">Dlmalloc</span><span class="op">&lt;</span><span class="ident">System</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Creates a new instance of an allocator</span>
    <span class="kw">pub</span> <span class="kw">const</span> <span class="kw">fn</span> <span class="ident">new</span>() -&gt; <span class="ident">Dlmalloc</span><span class="op">&lt;</span><span class="ident">System</span><span class="op">&gt;</span> {
        <span class="ident">Dlmalloc</span>(<span class="ident">dlmalloc::Dlmalloc::new</span>(<span class="ident">System::new</span>()))
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">A</span><span class="op">&gt;</span> <span class="ident">Dlmalloc</span><span class="op">&lt;</span><span class="ident">A</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Creates a new instance of an allocator</span>
    <span class="kw">pub</span> <span class="kw">const</span> <span class="kw">fn</span> <span class="ident">new_with_allocator</span>(<span class="ident">sys_allocator</span>: <span class="ident">A</span>) -&gt; <span class="ident">Dlmalloc</span><span class="op">&lt;</span><span class="ident">A</span><span class="op">&gt;</span> {
        <span class="ident">Dlmalloc</span>(<span class="ident">dlmalloc::Dlmalloc::new</span>(<span class="ident">sys_allocator</span>))
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">A</span>: <span class="ident">Allocator</span><span class="op">&gt;</span> <span class="ident">Dlmalloc</span><span class="op">&lt;</span><span class="ident">A</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Allocates `size` bytes with `align` align.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Returns a null pointer if allocation fails. Returns a valid pointer</span>
    <span class="doccomment">/// otherwise.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Safety and contracts are largely governed by the `GlobalAlloc::alloc`</span>
    <span class="doccomment">/// method contracts.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">malloc</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">size</span>: <span class="ident">usize</span>, <span class="ident">align</span>: <span class="ident">usize</span>) -&gt; <span class="kw-2">*mut</span> <span class="ident">u8</span> {
        <span class="kw">if</span> <span class="ident">align</span> <span class="op">&lt;</span><span class="op">=</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">malloc_alignment</span>() {
            <span class="self">self</span>.<span class="number">0</span>.<span class="ident">malloc</span>(<span class="ident">size</span>)
        } <span class="kw">else</span> {
            <span class="self">self</span>.<span class="number">0</span>.<span class="ident">memalign</span>(<span class="ident">align</span>, <span class="ident">size</span>)
        }
    }

    <span class="doccomment">/// Same as `malloc`, except if the allocation succeeds it&#39;s guaranteed to</span>
    <span class="doccomment">/// point to `size` bytes of zeros.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">calloc</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">size</span>: <span class="ident">usize</span>, <span class="ident">align</span>: <span class="ident">usize</span>) -&gt; <span class="kw-2">*mut</span> <span class="ident">u8</span> {
        <span class="kw">let</span> <span class="ident">ptr</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">malloc</span>(<span class="ident">size</span>, <span class="ident">align</span>);
        <span class="kw">if</span> <span class="op">!</span><span class="ident">ptr</span>.<span class="ident">is_null</span>() <span class="op">&amp;&amp;</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">calloc_must_clear</span>(<span class="ident">ptr</span>) {
            <span class="ident">ptr::write_bytes</span>(<span class="ident">ptr</span>, <span class="number">0</span>, <span class="ident">size</span>);
        }
        <span class="ident">ptr</span>
    }

    <span class="doccomment">/// Deallocates a `ptr` with `size` and `align` as the previous request used</span>
    <span class="doccomment">/// to allocate it.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Safety and contracts are largely governed by the `GlobalAlloc::dealloc`</span>
    <span class="doccomment">/// method contracts.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">free</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">ptr</span>: <span class="kw-2">*mut</span> <span class="ident">u8</span>, <span class="ident">size</span>: <span class="ident">usize</span>, <span class="ident">align</span>: <span class="ident">usize</span>) {
        <span class="ident">drop</span>((<span class="ident">size</span>, <span class="ident">align</span>));
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">free</span>(<span class="ident">ptr</span>)
    }

    <span class="doccomment">/// Reallocates `ptr`, a previous allocation with `old_size` and</span>
    <span class="doccomment">/// `old_align`, to have `new_size` and the same alignment as before.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Returns a null pointer if the memory couldn&#39;t be reallocated, but `ptr`</span>
    <span class="doccomment">/// is still valid. Returns a valid pointer and frees `ptr` if the request</span>
    <span class="doccomment">/// is satisfied.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Safety and contracts are largely governed by the `GlobalAlloc::realloc`</span>
    <span class="doccomment">/// method contracts.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">realloc</span>(
        <span class="kw-2">&amp;mut</span> <span class="self">self</span>,
        <span class="ident">ptr</span>: <span class="kw-2">*mut</span> <span class="ident">u8</span>,
        <span class="ident">old_size</span>: <span class="ident">usize</span>,
        <span class="ident">old_align</span>: <span class="ident">usize</span>,
        <span class="ident">new_size</span>: <span class="ident">usize</span>,
    ) -&gt; <span class="kw-2">*mut</span> <span class="ident">u8</span> {
        <span class="kw">if</span> <span class="ident">old_align</span> <span class="op">&lt;</span><span class="op">=</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">malloc_alignment</span>() {
            <span class="self">self</span>.<span class="number">0</span>.<span class="ident">realloc</span>(<span class="ident">ptr</span>, <span class="ident">new_size</span>)
        } <span class="kw">else</span> {
            <span class="kw">let</span> <span class="ident">res</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">malloc</span>(<span class="ident">new_size</span>, <span class="ident">old_align</span>);
            <span class="kw">if</span> <span class="op">!</span><span class="ident">res</span>.<span class="ident">is_null</span>() {
                <span class="kw">let</span> <span class="ident">size</span> <span class="op">=</span> <span class="ident">cmp::min</span>(<span class="ident">old_size</span>, <span class="ident">new_size</span>);
                <span class="ident">ptr::copy_nonoverlapping</span>(<span class="ident">ptr</span>, <span class="ident">res</span>, <span class="ident">size</span>);
                <span class="self">self</span>.<span class="ident">free</span>(<span class="ident">ptr</span>, <span class="ident">old_size</span>, <span class="ident">old_align</span>);
            }
            <span class="ident">res</span>
        }
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="dlmalloc" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>